// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package track_topics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPostTrackTopicsParams creates a new PostTrackTopicsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostTrackTopicsParams() *PostTrackTopicsParams {
	return &PostTrackTopicsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostTrackTopicsParamsWithTimeout creates a new PostTrackTopicsParams object
// with the ability to set a timeout on a request.
func NewPostTrackTopicsParamsWithTimeout(timeout time.Duration) *PostTrackTopicsParams {
	return &PostTrackTopicsParams{
		timeout: timeout,
	}
}

// NewPostTrackTopicsParamsWithContext creates a new PostTrackTopicsParams object
// with the ability to set a context for a request.
func NewPostTrackTopicsParamsWithContext(ctx context.Context) *PostTrackTopicsParams {
	return &PostTrackTopicsParams{
		Context: ctx,
	}
}

// NewPostTrackTopicsParamsWithHTTPClient creates a new PostTrackTopicsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostTrackTopicsParamsWithHTTPClient(client *http.Client) *PostTrackTopicsParams {
	return &PostTrackTopicsParams{
		HTTPClient: client,
	}
}

/*
PostTrackTopicsParams contains all the parameters to send to the API endpoint

	for the post track topics operation.

	Typically these are written to a http.Request.
*/
type PostTrackTopicsParams struct {

	/* TracktopicRequest.

	   An array of new TrackTopic records
	*/
	TracktopicRequest *members_models.TrackTopicRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post track topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTrackTopicsParams) WithDefaults() *PostTrackTopicsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post track topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostTrackTopicsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post track topics params
func (o *PostTrackTopicsParams) WithTimeout(timeout time.Duration) *PostTrackTopicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post track topics params
func (o *PostTrackTopicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post track topics params
func (o *PostTrackTopicsParams) WithContext(ctx context.Context) *PostTrackTopicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post track topics params
func (o *PostTrackTopicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post track topics params
func (o *PostTrackTopicsParams) WithHTTPClient(client *http.Client) *PostTrackTopicsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post track topics params
func (o *PostTrackTopicsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTracktopicRequest adds the tracktopicRequest to the post track topics params
func (o *PostTrackTopicsParams) WithTracktopicRequest(tracktopicRequest *members_models.TrackTopicRequest) *PostTrackTopicsParams {
	o.SetTracktopicRequest(tracktopicRequest)
	return o
}

// SetTracktopicRequest adds the tracktopicRequest to the post track topics params
func (o *PostTrackTopicsParams) SetTracktopicRequest(tracktopicRequest *members_models.TrackTopicRequest) {
	o.TracktopicRequest = tracktopicRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostTrackTopicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TracktopicRequest != nil {
		if err := r.SetBodyParam(o.TracktopicRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
