// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package track_topics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new track topics API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for track topics API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTrackTopics(params *GetTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackTopicsOK, error)

	PostTrackTopics(params *PostTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackTopicsOK, error)

	PutTrackTopics(params *PutTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutTrackTopicsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetTrackTopics gets a list track topics

Return a list of TrackTopic records from the datastore
*/
func (a *Client) GetTrackTopics(params *GetTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackTopicsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTrackTopicsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTrackTopics",
		Method:             "GET",
		PathPattern:        "/tracktopics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTrackTopicsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTrackTopicsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTrackTopics: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTrackTopics creates new track topics

Create TrackTopics
*/
func (a *Client) PostTrackTopics(params *PostTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackTopicsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTrackTopicsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTrackTopics",
		Method:             "POST",
		PathPattern:        "/tracktopics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTrackTopicsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTrackTopicsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTrackTopics: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PutTrackTopics updates track topic

Update TrackTopic
*/
func (a *Client) PutTrackTopics(params *PutTrackTopicsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PutTrackTopicsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutTrackTopicsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "putTrackTopics",
		Method:             "PUT",
		PathPattern:        "/tracktopics",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutTrackTopicsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutTrackTopicsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putTrackTopics: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
