// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetUsersAuthParams creates a new GetUsersAuthParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetUsersAuthParams() *GetUsersAuthParams {
	return &GetUsersAuthParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetUsersAuthParamsWithTimeout creates a new GetUsersAuthParams object
// with the ability to set a timeout on a request.
func NewGetUsersAuthParamsWithTimeout(timeout time.Duration) *GetUsersAuthParams {
	return &GetUsersAuthParams{
		timeout: timeout,
	}
}

// NewGetUsersAuthParamsWithContext creates a new GetUsersAuthParams object
// with the ability to set a context for a request.
func NewGetUsersAuthParamsWithContext(ctx context.Context) *GetUsersAuthParams {
	return &GetUsersAuthParams{
		Context: ctx,
	}
}

// NewGetUsersAuthParamsWithHTTPClient creates a new GetUsersAuthParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetUsersAuthParamsWithHTTPClient(client *http.Client) *GetUsersAuthParams {
	return &GetUsersAuthParams{
		HTTPClient: client,
	}
}

/*
GetUsersAuthParams contains all the parameters to send to the API endpoint

	for the get users auth operation.

	Typically these are written to a http.Request.
*/
type GetUsersAuthParams struct {

	/* Email.

	   Email address
	*/
	Email *string

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get users auth params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsersAuthParams) WithDefaults() *GetUsersAuthParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get users auth params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetUsersAuthParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get users auth params
func (o *GetUsersAuthParams) WithTimeout(timeout time.Duration) *GetUsersAuthParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get users auth params
func (o *GetUsersAuthParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get users auth params
func (o *GetUsersAuthParams) WithContext(ctx context.Context) *GetUsersAuthParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get users auth params
func (o *GetUsersAuthParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get users auth params
func (o *GetUsersAuthParams) WithHTTPClient(client *http.Client) *GetUsersAuthParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get users auth params
func (o *GetUsersAuthParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEmail adds the email to the get users auth params
func (o *GetUsersAuthParams) WithEmail(email *string) *GetUsersAuthParams {
	o.SetEmail(email)
	return o
}

// SetEmail adds the email to the get users auth params
func (o *GetUsersAuthParams) SetEmail(email *string) {
	o.Email = email
}

// WithLimit adds the limit to the get users auth params
func (o *GetUsersAuthParams) WithLimit(limit *int64) *GetUsersAuthParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get users auth params
func (o *GetUsersAuthParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get users auth params
func (o *GetUsersAuthParams) WithOffset(offset *int64) *GetUsersAuthParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get users auth params
func (o *GetUsersAuthParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetUsersAuthParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Email != nil {

		// query param email
		var qrEmail string

		if o.Email != nil {
			qrEmail = *o.Email
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
