// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package track_events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new track events API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for track events API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTrackEvents(params *GetTrackEventsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackEventsOK, error)

	PostTrackEvents(params *PostTrackEventsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackEventsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetTrackEvents gets a list track events

Return a list of TrackEvent records from the datastore
*/
func (a *Client) GetTrackEvents(params *GetTrackEventsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackEventsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTrackEventsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTrackEvents",
		Method:             "GET",
		PathPattern:        "/trackevents",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTrackEventsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTrackEventsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTrackEvents: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTrackEvents creates new track events

Create TrackEvents
*/
func (a *Client) PostTrackEvents(params *PostTrackEventsParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackEventsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTrackEventsParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTrackEvents",
		Method:             "POST",
		PathPattern:        "/trackevents",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTrackEventsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTrackEventsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTrackEvents: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
